Codeforces 610D Vika and Segments 线段树+离散化+扫描线

可以转变成上一题(hdu1542)的形式,把每条线段变成宽为1的矩形,求矩形面积并

要注意的就是转化为右下角的点需要x+1,y-1,画一条线就能看出来了

#include<bits/stdc++.h>
#define pi acos(-1.0)
#define ll long long
#define mod 1000000007
#define ls l,m,rt<<1
#define rs m+1,r,rt<<1|1
#pragma comment(linker, "/STACK:1024000000,1024000000")

using namespace std;

const double g=10.0,eps=1e-7;
const int N=200000+10,maxn=500+100,inf=0x3f3f3f;

int mark[N<<2];//某区间下底边个数
ll sum[N<<2];//某区间下底边总长度
ll Hash[N];//离散化数组
//把横坐标作为线段进行扫描
//扫描是为了更新下底边个数和下底边总长度,记录答案
struct tree{
    ll l,r,h;//l,r左右端点,h从x轴到该边的高
    int d;//-1上底边/1下底边
    tree(){}
    tree(ll x,ll y,ll z,int a):l(x),r(y),h(z),d(a){}
    bool operator <(const tree &a)const
    {
        return h<a.h;
    }
}s[N];
void pushup(int l,int r,int rt)
{
    if(mark[rt])sum[rt]=Hash[r+1]-Hash[l];
    else if(l==r)sum[rt]=0;
    else sum[rt]=sum[rt<<1]+sum[rt<<1|1];
}
void update(int L,int R,int d,int l,int r,int rt)
{
    if(L<=l&&r<=R)
    {
        mark[rt]+=d;//如果是上底边mark-1,下底边mark+1
        pushup(l,r,rt);
        return ;
    }
    int m=(l+r)>>1;
    if(L<=m)update(L,R,d,ls);
    if(R>m)update(L,R,d,rs);
    pushup(l,r,rt);
}
int Search(ll key,int n)
{
    int l=0,r=n-1;
    while(l<=r)
    {
        int m=(l+r)/2;
        if(Hash[m]==key)return m;
        if(Hash[m]>key)r=m-1;
        else l=m+1;
    }
    return -1;
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout<<setiosflags(ios::fixed)<<setprecision(2);
    int n;
    cin>>n;
    int k=0;
    for(int i=0; i<n; i++)
    {
        ll x1,x2,y1,y2;
        cin>>x1>>y1>>x2>>y2;
        if(x1==x2)
        {
            if(y1<y2)swap(y1,y2);
            x2++;
            y2--;
        }
        else
        {
            if(x1>x2)swap(x1,x2);
            x2++;
            y2--;
        }
        Hash[k]=x1;
        s[k++]= {x1,x2,y1,1}; //上底边
        Hash[k]=x2;
        s[k++]= {x1,x2,y2,-1}; //下底边
    }
    sort(Hash,Hash+k);
    sort(s,s+k);
    int m=1;
    for(int i=1; i<k; i++) //离散化
        if(Hash[i]!=Hash[i-1])
            Hash[m++]=Hash[i];
    ll ans=0;
    memset(sum,0,sizeof sum);
    memset(mark,0,sizeof mark);
    for(int i=0; i<k; i++) //如果两个下底边重合,但是上底边可能不一样,必须更新mark,而sum不会改变
    {
        int l=Search(s[i].l,m);//利用hash表查找
        int r=Search(s[i].r,m)-1;//这里的l,r实际上是Hash表的标号
        update(l,r,s[i].d,0,m-1,1);//维护mark和sum的值
        ans+=sum[1]*(s[i+1].h-s[i].h);//sum[1]当前的下底边长度总和
    }
    cout<<ans<<endl;
    return 0;
}
/*********************

*********************/

时间: 2024-10-10 10:37:56

Codeforces 610D Vika and Segments 线段树+离散化+扫描线的相关文章

hdu1828 Picture(线段树+离散化+扫描线)两种方法

C - Picture Time Limit:2000MS     Memory Limit:10000KB     64bit IO Format:%I64d & %I64u Submit Status Description A number of rectangular posters, photographs and other pictures of the same shape are pasted on a wall. Their sides are all vertical or

POJ 2482 Stars in Your Window 线段树+离散化+扫描线

题面据说很美- 每个星星可以根据在窗口的左下角和右上角两个位置建立两条扫描线,之后就是简单的区间增减和求最大值操作了. 注意要处理在边界上的星星是不算的情况,其实只要把左右边界分别增减一个eps即可. #include <cstdio> #include <cstring> #include <iostream> #include <map> #include <set> #include <vector> #include <

HDU 1542 Atlantis 线段树+离散化+扫描线

题意:给出一些矩形的最上角坐标和右下角坐标,求这些矩形的面积并. NotOnlySuccess 线段树专辑中扫描线模板题,弱智的我对着大大的代码看了一下午才搞懂. 具体见思路见注释=.= #include <cstdio> #include <cstring> #include <algorithm> #include <vector> #define lson rt<<1,l,mid #define rson rt<<1|1,mid

poj3277--City Horizon(线段树+离散化+扫描线)

City Horizon Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 16206   Accepted: 4414 Description Farmer John has taken his cows on a trip to the city! As the sun sets, the cows gaze at the city horizon and observe the beautiful silhouette

【POJ 2482】 Stars in Your Window(线段树+离散化+扫描线)

[POJ 2482] Stars in Your Window(线段树+离散化+扫描线) Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 11294   Accepted: 3091 Description Fleeting time does not blur my memory of you. Can it really be 4 years since I first saw you? I still remembe

HDU 3642 线段树+离散化+扫描线

题意:给你N个长方体的左下角和右上角坐标,问你空间中有多少体积是被大于两个不同的立方体覆盖的.x,y~10^6 z~500 考虑到给的z比较小,所以可以直接枚举z,然后跑二维的扫描线就好. 关于处理被不同的线段覆盖三次的问题,可以维护四个信息,cnt,once,twice,more,然后相互推出结果就好. #include <cstdio> #include <cstring> #include <vector> #include <algorithm> #

hdu1255--覆盖的面积(线段树+离散化+扫描线)

E - 覆盖的面积 Time Limit:5000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Description 给定平面上若干矩形,求出被这些矩形覆盖过至少两次的区域的面积. Input 输入数据的第一行是一个正整数T(1<=T<=100),代表测试数据的数量.每个测试数据的第一行是一个正整数N(1<=N<=1000),代表矩形的数量,然后是N行数据,每一行包含

poj1151-- Atlantis(线段树+离散化+扫描线)

Atlantis Time Limit:1000MS     Memory Limit:10000KB     64bit IO Format:%I64d & %I64u Submit Status Description There are several ancient Greek texts that contain descriptions of the fabled island Atlantis. Some of these texts even include maps of pa

POJ 1177/HDU 1828 picture 线段树+离散化+扫描线 轮廓周长计算

求n个图矩形放下来,有的重合有些重合一部分有些没重合,求最后总的不规则图型的轮廓长度. 我的做法是对x进行一遍扫描线,再对y做一遍同样的扫描线,相加即可.因为最后的轮廓必定是由不重合的线段长度组成的,这样理论上是对的 要注意处理高度相同的线段,把底边优先处理(在代码里就是f标记为1的线段),因为若是一个矩形的底边和另一个矩形的上边重合,则这个轮廓肯定不能算 不过POJ和HDU的数据好像都比较弱,我没进行上面的细节处理也AC了,不过一个很简单的数据就会不对,所以还是要处理一下才是真正正确的代码 我